%------Solving Maximum weight independent set using 
%------Quantum Computer----------------------------
clear all;
%----SETTING UP GRAPH INPUT -----------------------
N = 5;            
Weight_vector = [1 9 4 3 11];
%Weight_vector = [5 4 9 4 20];% WEIGHT OF VERTICES
%------------INVOKE ORACLE---------------------------
%---TO COMPUTE ALL POSSIBLE WEIGHT COMBINATIONS------
%---QUANTUM COMPUTER WILL DO IT IN PARALLEL----------
R = 0;
for i = 0:1:power(2,N)-1 % CONSTANT TIME OPERATION FOR QC
    f = fliplr(d2b(i,N));
    R(i+1) = sum(f.*Weight_vector);
end
%-----------FINAL HAMILTONIAN----------------------
Vi = R';
Hf = Gen_Hamiltonian(Vi);
%H = hadamard(32);
spgap = 0;
% Hi = H*Hi*H';
%--------INTERMEDIATE CONSTRAINT ORACLE--------------
Oracle_Vector=0;
for i = 0:1:power(2,5)-1    % CONSTANT TIME OPERATION FOR QC
    f = fliplr(d2b(i,N));
    c1 = f(1)+f(2)<=1;
    c2 = f(1)+f(3)<=1;
    c3 = f(1)+f(4)<=2;
    c4 = f(1)+f(5)<=1;
    c5 = f(2)+f(3)<=1;
    c6 = f(2)+f(4)<=2;
    c7 = f(2)+f(5)<=1;
    c8 = f(3)+f(4)<=1;
    c9 = f(3)+f(5)<=2;
    c10 = f(4)+f(5)<=1;
Oracle_fun_outp = c1 & c2 & c3 & c4 & c5 & c6 & c7 & c8 & c9 & c10;
% Writing oracle
Oracle_Vector(i+1) = -power(-1,Oracle_fun_outp+1);
end

%-----------CONSTRAINT HAMILTONIAN----------------------
Vi = Oracle_Vector;
Hc = Gen_Hamiltonian(-Vi);

%-----PREPARE QUANTUM STATE IN INITIAL HAMILTONIAN------
system_quantum_state = ones(1,32)'; % Ground state of Hi

%--Adiabatic search Hc to Hc + I 
%----Setting parameters---------------------------------
step_size = 1/50;
T = 1;
% counter may used for plotting
c = 0;
% start your engines gentlemen
x = system_quantum_state;
for f = 0 : step_size : T
    c = c+1;
    H = Hc - f*eye(32);
    x = H*x;
    x = x/norm(x);
    [v,e] = eig(H);
    d = eig(H);
    f11 = v\x;
    f11 = f11/norm(f11);
   % stem(d,abs(f11),'r','*'), xlabel 'payoff', ylabel 'probability of getting this payoff' 
   % F(c) = getframe;
end
%--Adiabatic search Hc + I to Hf

y = x;
Hf = Hf;

%----Setting parameters---------------------------------
%step_size = 1/1;
Hi = H;
c = 0;
x = system_quantum_state;
for f = 0 : step_size : T
    c = c+1;
    H = (1-f)*Hi + f*Hf;
    sp_gap(c) = spectral_gap(H);
    x = H*x;
    x = x/norm(x);
    [v,e] = eig(H);
    d = -eig(H);    % so that weight eigen values become+ve
    f11 = v\x;
    f11 = f11/norm(f11);
    f11 = f11.*f11;
    stem(d,abs(f11),'r','*'), xlabel 'Maximum weight', ylabel 'probability of getting this weight' , axis ([-20 30 -0.01 2]),grid on;
    F(c) = getframe;
end
[x y R']
% stem([1:c],sp_gap)
 x = abs(x);
 ind = find(x==max(x));
solution_vector = zeros(N,1);
 for i = 1:length(ind)
    solution_vector(:,i) = fliplr(d2b(ind(i)-1,N))';
    Maximum_weight = -Hf(ind(i),ind(i));
 end
solution_vector
 Maximum_weight = -Hf(ind,ind)
