clear all;

w = [1 1]';
x = [1 1 1 1]';
y = [1 1 1 1 1 1 1 1]';
z = ones(16,1);

Aw = [-1 0;
      0 -0.95];
Ax = [-1 0 0 0;
      0 -0.954 0 0;
      0 0 -0.1 0;
      0 0 0 -0.3];
  
Ay = [-0.05 0 0 0 0 0 0 0;
      0 -0.3 0 0 0 0 0 0;
      0 0 -0.15 0 0 0 0 0;
      0 0 0 -0.4 0 0 0 0;
      0 0 0 0 -0.6 0 0 0;
      0 0 0 0 0 -0.8 0 0;
      0 0 0 0 0 0 -1 0;
      0 0 0 0 0 0 0 -0.955];

Az = -kron(Ax,Ax);
Az(2,2) = -0.95;
%Az = mpower(2.7,-Ay);


conv_w = 0;
conv_x = 0;
conv_y = 0;
conv_z = 0;

N = 60;

for i = 1:N
    w = Aw*w;
    w = w/norm(w);
    x = Ax*x;
    x = x/norm(x);
    y = Ay*y;
    y = y/norm(y);
    z = Az*z;
    z = z/norm(z);
    
    conv_w(i) = norm(w,Inf);
    conv_x(i) = norm(x,Inf);
    conv_y(i) = norm(y,Inf);
    conv_z(i) = norm(z,Inf);


end
plot([0:N-1],conv_w,[0:N-1],conv_x,[0:N-1],conv_y,[0:N-1],conv_z),xlabel('Time units spend in evolution'),ylabel('probability of measuring correct solution');legend('Hamiltonian [2x2], spectral gap: 0.05','Hamiltonian [4x4],spectral gap: 0.05','Hamiltonian [8x8],spectral gap: 0.05','Hamiltonian [16x16],spectral gap: 0.05'),grid on;axis([0 N 0 1.1]);
