clear all;
%-----------INITIAL HAMILTONIAN------------

Vi = [0.1 1 1 2 1 2 2 3 1 2 2 3 2 3 3 4];
Hi = Gen_Hamiltonian(Vi);

%-----------ONE ITEM TWO BIDERS------------

Quantum_state_bidder1 = [1 zeros(1,3)]';
Quantum_state_bidder2 = [1 zeros(1,3)]';
% system_quantum_state;

%--------POSSIBLE CHOICES OF BID VALUES---------
Had = Hadamard(2);
Had = Had/norm(Had);
% 0$ Bid
U0 = eye(4);
% $1 Bid
U1 = kron(eye(2),Had);  
% $2 Bid
U2 = kron(Had,eye(2));  
% $3 Bid
    Up = kron(Had,eye(2));
    CNOT = [1 0 0 0;
            0 1 0 0;
            0 0 0 1;
            0 0 1 0];

U3 = CNOT*Up;
%---------------Bidders preferences------------------
% Let us take example input
% Bidder1 chooses 
% Bidder2 chooses 

Quantum_state_bidder1 = U2*Quantum_state_bidder1;
Quantum_state_bidder2 = U3*Quantum_state_bidder2;

%-----------Superposition of quantum states of two users-----------
system_quantum_state = kron(Quantum_state_bidder1,Quantum_state_bidder2)

%----Preparing initial and final Hamiltonian----------
% Defining eigen vector for initial Hamiltonian
U = kron(U2,U3); 
% Initial Hamiltonian
Hi = U*Hi*U';

% Payoff vector for final Hamiltonian;
V = [0 -1 -2 -3 -1 0 0 0 -2 0 0 0 -3 0 0 0];
% Final Hamiltonian
Hf = Gen_Hamiltonian(V);

%----Starting adiabatic search------------------------

%----Setting parameters-------------------------------
step_size = 1/10;
T = 1;
% counter may used for plotting
c = 0;
% start your engines gentlemen
x = system_quantum_state;
for f = 0 : step_size : T

    c = c+1;
    
    H = (1-f)*Hi + f*Hf;
 
    x = H*x
    x = x/norm(x);

    [v,e] = eig(H);
    d = eig(H);
    
    f11 = v\x;
    f11 = f11/norm(f11);
    f11 = f11.*f11;
    stem(d,abs(f11),'r','*'), xlabel 'payoff', ylabel 'probability of getting this payoff' , axis ([-5 5 -0.01 2]),grid on;

    F(c) = getframe;
    
end
%------Measurement----------------------------
 x = x/norm(x);
 x = x.*x;
 x = abs(x);
 ind = find(x==max(x));
solution_vector = zeros(4,1);
 for i = 1:length(ind)
    solution_vector(:,i) = (d2b(ind(i)-1,4))';
    Maximum_weight = -Hf(ind(i),ind(i));
 end
solution_vector
 Maximum_payoff = Hf(ind,ind)