clear all;

%----------Let us prepare different types of unitary input matrices ----------

u2 = power(2,-0.5);

k=5^-0.5;

U =   [1 0 0 0;          % 
       0 0 0 1;
       0 0 1 0;
       0 1 0 0];

%U = hadamard(2)*u2;     % has rational theta, estimation requires 1 qubit

%U = [0 1;1 0];          % has rational theta, estimation requires 1 qubit


CU = [1 0 0 0 0 0 0 0;   % Converting Unitary matrix into Controlled unitary matrix
      0 1 0 0 0 0 0 0;
      0 0 1 0 0 0 0 0;
      0 0 0 1 0 0 0 0;
      0 0 0 0 1 0 0 0;
      0 0 0 0 0 0 0 1;
      0 0 0 0 0 0 1 0;
      0 0 0 0 0 1 0 0];
      
[v,e] = eig(U)          % Find out eigen vectors and eigen values

%---phase = 1.1071 rad (approx) and theta = 0.1762 rad (approx)---------

sI = v(:,1);            % For first eigen vector or (sI) we will estimate theta of corresponding eigen value

ctr_inp = [1;1];        % Preparing 0> + 1>

inp_vec = kron(ctr_inp,sI); % Preparing (0> + 1>)tensor product with si

%---------start ur engine boys------------

N = 12;                 % theta will be estimated in N qubits
bit = 0;

for l = 1:N
k = N - l + 1;

%--------Go Go Go--------------------

    ss = inp_vec;

    for i = 1:2^(k-1)
        ss = CU*ss;
    end

    [x,y] = deckron(ss,2,4);    % resolves tensor product into si and controlled qubit

%-------------Applying controlled phase shift transformation--------------------

    for m = 1:l-1
        x = CR_1(l-m+1,x,bit(m));
    end
%------------Measuring qubits in classical basis----------------

    pp = hadamard(2)*x;
    bit(l) = pp(1)<pp(2);  % We do that when to measure relative probabilities of ones and zeros
 
 end   
  
%-----------------------------------
est_ph = b2d_1(fliplr(bit)) % eigen value = exp(2*pi*i*theta)
